package com.anychart.tips.designModeSample {
	import mx.controls.Image;
	import mx.core.UIComponent;
	import mx.core.UIComponentGlobals;

	public class DesignModeComponent extends UIComponent {
		
		[Embed(source="./assets/lg.png")]
		private static var EmbedLivePreviewImg:Class;
		
		private static var LOGO_WIDTH:Number = 267;
		private static var LOGO_HEIGHT:Number = 91;
		
		private var logo:Image;
		
		public function DesignModeComponent() {
			width = 300;
			height = 100;
		}
		
		override protected function measure():void {
			super.measure();
			measuredMinWidth = 50;
			measuredMinHeight = 50;
		}
		
		override protected function createChildren():void {
			super.createChildren();
			if (UIComponentGlobals.designMode) {
				logo = new Image();
				logo.source = EmbedLivePreviewImg;
				addChild(logo);
			}
		}
		
		override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void {
			super.updateDisplayList(unscaledWidth, unscaledHeight);
			
			if (UIComponentGlobals.designMode) {
				graphics.clear();
				graphics.beginFill(0x4E4E4E,1);
				graphics.drawRect(0,0,unscaledWidth, unscaledHeight);
				
				var lWidth:Number = LOGO_WIDTH;
				var lHeight:Number = LOGO_HEIGHT;
				
				if (unscaledWidth < LOGO_WIDTH || unscaledHeight < LOGO_HEIGHT) {
					var scale:Number = Math.min(unscaledWidth/LOGO_WIDTH,unscaledHeight/LOGO_HEIGHT);
					lWidth *= scale;
					lHeight *= scale;
				}
				logo.width = lWidth;
				logo.height = lHeight;
				
				logo.x = (unscaledWidth - lWidth)/2;
				logo.y = (unscaledHeight - lHeight)/2;
			}else {
				graphics.clear();
				graphics.beginFill(0xCCCCCC,1);
				graphics.drawRect(0,0,unscaledWidth, unscaledHeight);
			}
		}
	}
}